function enable_all(s)
	local k,v
	if not objs(s) then
		return
	end
	for k,v in ipairs(objs(s)) do
		local o = ref(v);
		if isObject(o) then
			o:enable()
		end
	end
end

function disable_all(s)
	local k,v
	if not objs(s) then
		return
	end
	for k,v in ipairs(objs(s)) do
		local o = ref(v);
		if isObject(o) then
			o:disable()
			o.Hidden = true;
		end
	end
end

function container(s)
	local k,v,r
	r = '';
	if not s.Opened then
		return
	end
	for k,v in ipairs(objs(s)) do
		local o = ref(v);
		if isObject(o) then
			if r ~= '' then
				r = r..', ';
			end
			r=r..xref(o.nam, o);
		end
	end
	if r ~= '' then
		return ' Предметы внутри: '..r..'.';
	end
end

Look = obj {
	action_type = true,
	nam = '> осмотреть',
	inv = 'Что именно осмотреть?',
	use = function(s, w)
		if ref(w).action_type then
			return
		end
		if not ref(w).exam then
			return 'Ничего особенного...', false;
		end
		return call(ref(w),'exam'), false;
	end,
};


Open = obj {
	action_type = true,
	nam = '> открыть',
	inv = 'Что именно?',
	use = function(s, w)
		if ref(w).action_type then
			return
		end
		if not ref(w).open then
			return 'Это нельзя открыть...', false;
		end
		
		if ref(w).Opened then
			return 'Уже открыто...', false;
		end
		
		local r,v=call(ref(w),'open');
		if v ~= false then
			ref(w).Opened = true;
			enable_all(w);
		end
		return r, false
	end,
};

Close = obj {
	action_type = true,
	nam = '> закрыть',
	inv = 'Что именно?',
	use = function(s, w)
		if ref(w).action_type then
			return
		end
		if not ref(w).close then
			return 'Это нельзя закрыть...', false;
		end
		if not ref(w).Opened then
			return 'Уже закрыто...', false;
		end

		local r,v=call(ref(w),'close');
		if v ~= false then
			ref(w).Opened = false;
			disable_all(w);
		end
		return r, false;

	end,
};

Take = obj {
	action_type = true,
	nam = '> взять',
	inv = 'Что взять?',
	use = function(s, w)
		if ref(w).action_type then
			return
		end
		if have(w) then
			return 'У вас уже это есть.', false;
		end
		if not ref(w).take then
			return 'Это нельзя взять...', false;
		end
		local r,v= call(ref(w),'take');
		if v ~= false then
			take(w);
			ref(w).Hidden = false;
		end
		return r, false
	end,
};

Drop = obj {
	action_type = true,
	nam = '> положить',
	inv = 'Что положить?',
	use = function(s, w)
		if ref(w).action_type then
			return
		end
		if not have(w) then
			return 'У вас нет этого.', false;
		end
		if not ref(w).drop then
			return 'Это нельзя положить...', false;
		end
		local r,v=call(here(), 'drop', w) 
		if not r then
			 r,v = call(ref(w),'drop');
		end
		if v ~= false then
			drop(w);
		end
		return r, false;
	end,	
};

Push = obj {
	action_type = true,
	nam = '> толкнуть',
	inv = 'Что толкнуть?',
	use = function(s, w)
		if ref(w).action_type then
			return
		end
		if not ref(w).push then
			return 'Это нельзя толкнуть...', false;
		end
		local r = call(ref(w),'push');
		return r, false;
	end,	
};

Eat = obj {
	action_type = true,
	nam = '> съесть',
	inv = 'Что съесть?',
	use = function(s, w)
		if ref(w).action_type then
			return
		end
--		if not have(w) then
--			return 'У вас этого нет...', false;
--		end
		if not ref(w).eat then
			return 'Это нельзя есть...', false;
		end
		local r,v=call(ref(w),'eat');
		if v ~= false then
			inv():del(w);
		end
		return r, false
	end,	
};

Talk = obj {
	action_type = true,
	nam = '> поговорить',
	inv = 'С кем поговорить?',
	use = function(s, w)
		if ref(w).action_type then
			return
		end
		if not ref(w).talk then
			return 'С этим нельзя говорить...', false;
		end
		local r,v=call(ref(w),'talk');
		return r, false
	end,	
};

sep = obj {
	nam = ' ';
};


inv():add(Look);
inv():add(Take);
inv():add(Drop);
inv():add(Push);
inv():add(Open);
inv():add(Close);
inv():add(Eat);
inv():add(Talk);
inv():add(sep); 
sep.object_type = false;

function iobj(v)
	v.act = function(s)
		local r,v = call(s, 'useit', nil);
		if not r then
			return 'Что с этим делать?';
		end
		return r;
	end
	v.inv = function(s)
		local r,v = call(s, 'useit', nil);
		if not r then
			return 'Что с этим делать?';
		end
		return r;
	end
	v.dsc = function(s)
		if s.Hidden then
			return
		end
		if not me().Light and not here().Light and not s.Light then
			return
		end
		local r = call(s, 'desc');
		if s.Opened and s.container_type then
			r = cat(r, container(s));
		end
		return r;
	end

	if not v.push then
		v.push = 'Зачем это толкать?';
	end

	if v.Light == nil then
		v.Light = false;
	end
--	if not v.Opened then
--		disable_all(v);	
--	end
	return obj(v);
end

function iroom(v)
	v.dsc = function(s)
		if s.Hidden then
			return nil
		end
		if not me().Light and not s.Light then
			return 'Темно, ничего не видно.';
		end
		return call(s, 'desc');
	end
	if v.Light == nil then
		v.Light = true;
	end
	return room(v);
end

function movein(w, s, f)
	move(w, s, f);
	ref(w).Hidden = true;
end

-- for aliases
act = {
	exam = function(s)
		return call(s, 'exam');
	end,
	take = function(s)
		return call(s, 'take');
	end,
	drop = function(s)
		return call(s, 'drop');
	end,
	push = function(s)
		return call(s, 'push');
	end,
	eat = function(s)
		return call(s, 'eat');
	end,
	talk = function(s)
		return call(s, 'talk');
	end,
	open = function(s)
		return call(s, 'open');
	end,
	close = function(s)
		return call(s, 'close');
	end
};

