-- $Name:Среди руин$
-- $Version:0.1$
dofile('actions.lua');

game.Score = 0

MAX_SCORE = 30

function sign(v) 
	v.sign_type = true;
	v.exam = 'Гм... Посмотреть в словаре?';
	return iobj(v);
end

set_music("mus/misery.xm");

main = iroom {
	nam = 'СРЕДИ РУИН',
	desc = function (s)
        	local v = txtem(txtr([[
			Но Аллигатор не выроет нору^
			Что станет могилой ему,^
			Но выроет он нору^
			Как убежище себе.^
			-- из "Пополь Вух"]]));
       		v = v..[[^^Эту версию собрал Роджер Фирт (Май 2001) из множества фрагментов игры,
	       	которые можно найти в Версии 4/1 Inform Designer's Manual.^^

		Русская версия: Гаев Д.Г. (август 2004)^^
		Версия для INSTEAD: Петр Косых (сентябрь 2009)]];
		return v;
	end,
	exit =  [[...Позади осталось много дней бесплодных поисков
         и мучительного пути сквозь колючие лесные дебри...
         Но теперь, кажется, Ваше терпение и упорство получили награду.
         Это -- открытие, и какое!]],
	obj = { vway('дальше', '{Дальше}.', 'Forest') },
};

sodium_lamp = iobj {
	Light = true,
	nam = 'лампа',
	Battery_power = 120,
        desc = function(s) 
        	if (s.On) then
			return "Зажженная натриевая {лампа} стоит на земле.";
		end
		return "Натриевая {лампа} стоит на земле.";
	end,
	exam = function(s)
		local v;
		v = "Мощная археологическая натриевая лампа";
		if not s.On then return v.." (в данный момент выключенная)."; end
		if s.Battery_power < 10 then v = v..", горящая тусклым желтым светом.";
		else v = v.."горящая ярким желтым светом."; end
		return v;
	end,
	drop = function(s)
		return 'Вы поставили лампу на землю.';
	end,
	take = function(s)
		if s.On then
			return [[Лампа слишком хрупка, а ее металлическая ручка слишком горяча,
                     чтобы ее можно было переносить в зажженном виде.]], false;
		end
		return 'Вы взяли лампу.';
	end,
	use = function(s)
		return 'Вы должны зажечь лампу, если хотите осветить что-нибудь.', false
	end,
	useit = function(s)
		if s.On then
			s.On = false;
			where(s).Light = s.SLight;
			return 'Вы потушили лампу.';
		end
		
		if s.Battery_power <= 0 then
			return "К сожалению, энергия батареи иссякла.";
		end
		if have(s) then
			return "Прежде, чем зажечь лампу, ее необходимо поставить на землю.";
		end
		s.On = true;
		s.SLight = where(s).Light;
		where(s).Light = true;
		return cat('Вы зажгли лампу.^^', goto(here()));
	end,
	push = function(s)
		return 'Вы немного подвинули лампу.';
	end,
        life = function(s) 
		if not s.On then return; end
		s.Battery_power = s.Battery_power - 1;
		if s.Battery_power <= 0 then
			s.On = false;
			where(s).Light = s.SLight;
		end
		if not have(s) then
			if (s.Battery_power == 0) then
				lifeoff(s);
				return "Лампа погасла!!!";
			elseif (s.Battery_power <= 5) then
				return "Лампа почти полностью погасла.";
                	elseif (s.Battery_power <= 10) then
	                    	return "Свет лампы заметно потускнел!";
			end
		end
	end
}

map = iobj {
	nam = 'карта',
        exam = [[Карта Квитаны-Ру. На эту карту нанесен Ваш путь сквозь дебри дождевого леса
             по руслу ручья от юго-восточных границ Мексико,
             завершившийся на этом высоком плато.]],
};

dictionary = iobj {
	nam = "словарь",
	exam = [[ Словарь глифов Вальдека.
            Основанный на ненадежных литографиях легендарного путешественника
             и искателя приключений "Графа" Жана Фредерика Максимилиана Вальдека
             (1766??-1875), этот словарь содержит в себе то очень немногое,
             что известно о символах местной разновидности письменности Майя.]],
	open = act.exam,
	close = 'Вы закрыли словарь.',
	use = function(s, w)
		if w == 'q1' then
			return 'Q: "священное место".';
		end
		if w == 'arrow' then
			return 'СТРЕЛА: "путешествие; становиться".';
		end

		if w == 'circle' then
			return 'КРУГ: "Солнце; также жизнь, время жизни".';
		end
		if w == 'halfmoon' then
			m_dlg:pon(5);
                	return [[ПОЛУМЕСЯЦ: предположительно, произносится "шибальба",  точное значение неизвестно.]];
		end
		if w == 'bird' then
			if (s.Correct) then 
				return 'ПТИЦА: "мертвый, как камень"!';
			else
				return 'ПТИЦА: "богатый, изобильный?".';
			end
		end
		if ref(w).sign_type then
			return 'Этого слова нет в словаре...';
		end
		return "Гм...";
	end
}

mushroom  = iobj {
	nam = 'гриб',
        desc = [[Покрытый темными пятнами {гриб} на длинной тонкой ножке
             торчит из влажной мягкой земли.]],
        exam = [[ Шляпка гриба покрыта темными пятнами неприятного вида,
             усиливающими подозрение в его ядовитости.]],
	take = function(s)
        	if (s.Mushroom_picked) then
			return "Вы подняли медленно разлагающийся гриб.";
		end
	        s.Mushroom_picked = true;
	        return "Вы взяли гриб, аккуратно расщепив тонкую ножку.";
	end,
	drop = function(s)
		return "Слегка потрепанный гриб упал на землю.";
	end,
	eat = function(s)
		if not have(s) then
			return 'Может, сначала взять гриб?';
		end
		step_signs:enable();
		steps.Rubble_filled = false;
		local l = [[Вы осторожно откусили от шляпки маленький кусочек...
        	         Едкий, неприятный вкус как будто заполнил весь окружающий мир...
                	 Полет попугая над головой оглушил Вас, шум его крыльев
	                 удивительно напоминает грохот медленно осыпающихся камней...]];
		if here() == steps then
		        return cat(l, '^^', goto(here()));
		else
			return l
		end
	end,
}

Forest = iroom {
	enter = function(s, w)
		if w == 'main' then
			game.pl = 'pl'
		end
	end,
	back = room {
		nam = 'назад',
		enter = function(s)
			if game.Score == MAX_SCORE then
				return goto('theend');
			end
			return [[Путь назад преграждает почти непроходимый дождевой лес,
	             и Вы прорубались сквозь него много дней подряд не для того,
	             чтобы оставить свое открытие и уйти с пустыми руками.
	             Вам надо сделать хотя бы несколько интересных находок,
	             прежде чем вернуться к цивилизации.]], false
		end
	},
	up = room {
		nam = 'наверх',
		enter = function(s)
        		return [[Стволы деревьев усеяны множеством острых шипов.
              Невозможно забраться по ним, не изрезав себе руки в клочья.]], false
		end
	},
	nam =  "Широкое Плато",
	way = { vroom('вниз', 'steps'), 'Forest.back', 'Forest.up' },
	desc = [[ Широкое Плато. Именно так в Ваших записях названо это невысокое известняковое плато,
             затерянное где-то в дебрях дождевого леса. Со всех сторон его окружает
             оливковая зелень деревьев; после недавно прошедшего теплого дождя
             воздух полон влажного тумана и назойливой мошкары.
             "Структура номер 10" -- это хаотическое нагромождение каменных обломков,
             некогда бывших погребальной пирамидой. От нее уцелело очень немногое --
             лишь высеченные в камни грубые ступени, ведущие куда-то вниз,
             в непроглядную тьму.]],
	obj = { 'mushroom', 'packing_case', 'low_mist'},
}

packing_case = iobj {
	container_type = true,
	nam = "ящик",
        desc = [[ На земле стоит большой упаковочный {ящик},
             предназначенный для найденных Вами предметов древней культуры,
             представляющих научный интерес.]],
	open = function(s)
		return 'Вы открыли ящик.';
	end,
	close = function(s)
		return 'Вы закрыли ящик.';
	end,
        take = function(s)
        	return [[Ящик слишком тяжел и громоздок, чтобы с ним возиться --
	                 по крайней мере, до полного завершения экспедиции.]], false;
	end,
	push = act.take,
	used = function(s, w)
		if not s.Opened then
			return 'Ящик закрыт.', false;
		end
		if ref(w).drop then
			drop(w);
			movein(w, s); 
		else
			return 'Зачем?', false;
		end
	end,
	obj = { 'camera', 'newspaper' }
}

camera  = iobj {
	nam = "фотокамера",
	Hidden = true,
        desc = 'Здесь лежит {фотокамера}.',
	useit = [[ С помощью фотокамеры можно делать снимки. ]],
	exam =  [[Громоздкая, массивная, неповоротливая фотокамера,
             рассчитанная на мокроколлодионные пластинки.
             Как и у большинства археологов, Ваши чувства
             к ней колеблются между любовью и ненавистью.]],
	take = 'Вы взяли камеру.',
	use = function(s, w)
		if not ref(w).cultural_value then
			return 'Это не представляет никакой культурной ценности.', false
		end
	end,
	drop = 'Вы положили камеру.',
};

newspaper = iobj {
	nam = "газета",
	Hidden = true,
        desc = 'На земле лежит {газета}.',
	useit = [[ Использовать газету? Хмм... ]],
	exam = [[Старый номер "Таймс" от 26 февраля 1938 г., одновременно
             сырой и ломкий после месячного воздействия здешнего климата --
             Вы сами чувствуете себя примерно так же.
             В Лондоне, как обычно, туман.]],
	take = 'Вы взяли газету.',
	drop = 'Вы положили газету.',
};

q1 = sign {
	nam = 'q1',
};


step_signs = sign {
	nam = 'письмена',
	desc = function(s)
		return 'На верхней ступени изображен знак:'..xref('Q.',q1);
	end,
	obj = {'q1'},
} : disable();

steps  = iroom {
	Rubble_filled = true,
	nam = 'По ступеням',
	way = { vroom('наверх','Forest'), vroom('вниз', 'Square_Chamber') },
        desc = function(s)
		local v = 'Вы находитесь на ступенях, ведущих вниз. ';
        	if s.Rubble_filled then
            		v = v.."После первых ступеней путь преграждает груда камней.";
		else
			v = v.."Потрескавшиеся, стертые каменные ступени ведут в темную глубину.";
		end
			        
		if Square_Chamber.Visited then
	                v = v.." Вы -- первый, кто спускается";
	        else
                	v = v.." Вы были первым, кто спустился";
		end
	        v = v..[[ по ним за последние пятьсот лет.]]
		return v;
	end,
	obj = { 'step_signs' },
	exit = function(s, to)
		if to == 'Square_Chamber' then
			if s.Rubble_filled then
				return "Непроходимый каменный завал не дает спуститься вниз.", false;
			end
		end
	end,
}

arrow = sign {
	nam = 'стрела',
--	desc = '{Стрела}.',
};

circle = sign {
	nam = 'круг',
--	desc = '{Круг}.',
};

square_signs = sign {
	nam = 'письмена',
	desc = function(s)
		return 'Вы различаете два символа: '..xref('стрела', arrow)..' и '..xref('круг.', circle);
	end,	
	obj = { 'arrow', 'circle' }
} : disable();


Square_Chamber = iroom {
	nam = 'Квадратная камера',
	enter = function(s)
		s.Visited = true
	end,
	desc = [[Глубокое и мрачное каменное подземелье, примерно десять на десять ярдов.
             За низкими дверными проходами, открывающимися на юг и на восток,
             лежит непроглядная тьма.]],
	way = { vroom('наверх', 'steps'), vroom('на восток', 'Wormcast'), vroom('на юг', 'Corridor') },
	obj = { iobj {
			nam = 'луч',
			desc = [[ Со ступеней, ведущих на поверхность, пробивается яркий {луч}
		             солнечного света, освещая подземелье рассеянным светом.]],
		     	exam = [[Мириады крошечных пылинок, пляшущих в луче света,
		             делают его не только видимым, но и почти осязаемым.]],
			used = function(s, w)
				if w == 'eggsac' then
					inv():del('eggsac');
					take('stone_key');
		                	return [[Вы положили кокон на пол в пятно яркого солнечного света.
			                     Он словно вскипел, раздулся и через мгновение взорвался
			                     сотнями крошечным насекомых, бросившихся в разные стороны
			                     в поисках темноты. На каменном полу осталась лишь лужица слизи,
			                     а в ней -- любопытный каменный ключ.]];
				end
			end
		     	},
		'stone_writings', 'square_signs', 'low_mist' },
	exit = function(s, to)
		if have('eggsac') and here() == Square_Chamber and to == 'steps' then
			return  cat([[В тот момент, когда луч дневного света упал на кокон,
                     он буквально вскипел и распался на части. Прежде, чем
                     Вы его успели отшвырнуть, он превратился в рой маленьких,
                     но жадных насекомых, которые набросились на Вас...]],goto('gameover'));
		end
	end,	     
}

stone_writings = iobj {
	nam = 'надпись',
	desc = "Стены, пол и потолок покрыты {знаками}, глубоко высеченными в камне.",
        exam = function(s)
		square_signs:enable();
		return [[Каждый раз, когда Вы смотрите на непонятные знаки, они неподвижны.
             Но трудно избавиться от ощущения, что как только Вы отводите взгляд,
             они оживают и начинают ползать по стенам.
             Два символа явно преобладают: Стрела и Круг.]];
	end,
}

Corridor = iroom {
	nam = "Неровный коридор",
	desc = "Низкий, квадратный в сечении неровный коридор ведет с севера на юг.",
	way = { vroom('на север', 'Square_Chamber'), vroom('на юг', 'Shrine') },
	obj = { 'statuette', 'StoneDoor' },
	Light = false, 
}

function have_treasure()
	local i,v
	for i,v in ipairs(inv()) do
		if isObject(ref(v)) and ref(v).cultural_value then
			return true
		end
	end
	return false
end

function treasure(v)
	v.drop = function(s)
		return 'Бросить это? Никогда!!!', false
	end
	v.take = function(s)
		if seen(s, packing_case) then
                	return [[С распаковкой столь бесценного артефакта
                     стоит подождать возвращения в Институт.]], false;
		end
		
         	if have_treasure() then
			return 'Вы не можете таскать с собой несколько артефактов.', false
		end 
		
		if not s.Photographed_in_situ then
			return [[На дворе тридцатые годы -- старые недобрые времена прошли.
                     Прежде, чем взять артефакт, надо запечатлеть для науки его
                     оригинальное местонахождение -- иначе это просто воровство!]], false;
	     	end
		return 'Вы взяли это!';
	end
	v.used = function(s, w)
		if w == 'camera' then
                	if s.Photographed_in_situ then
				return "Одного раза вполне достаточно.";
			end
                	s.Photographed_in_situ = true;
			return "Вы сфотографировали артефакт.";
		end
	end
	v.use = function(s, w)
		if w == 'packing_case' then
			drop(s);
			movein(s, w);
                    	game.Score = game.Score + s.cultural_value;
                    	if game.Score == MAX_SCORE then
                        	return [[Когда Вы тщательно упаковали артефакт в ящик,
	                         большой краснохвостый ара поднялся в небо с верхушки дерева,
	                         вновь оглушая Вас шумом своих тяжелых крыльев,
	                         напоминающим грохот далекого камнепада...
	                         После этого ночное небо прояснилось,
	                         а высоко над тихими джунглями поднялся серп луны.
	                         Март 1938 года подошел к концу, 
	                         а для Вас настало время вернуться домой.]];
			end
			return 'Артефакт надежно упакован.';
		end
	end
	if v.cultural_value == nil then
		v.cultural_value = 5
	end
	v = iobj(v);
	return v;
end

statuette = treasure {
	nam = 'статуэтка',
        cultural_value = 5,
	desc = "Здесь находится маленькая, но ценная {статуэтка}!",
        exam = "Статуэтка изображает что-то вроде нимфы со змеей, обвившейся вокруг шеи.",
}

StoneDoor = iobj {
	nam = 'дверь',
        exam = "Массивная желтая каменная дверь.",
	desc = function(s)
		if s.Opened then
            		return "Желтая каменная {дверь}, ведущая на юг, теперь открыта!";
		end
            	return "Путь на юг преграждает закрытая {дверь} из желтого камня.";
	end,
	open = function(s, w)
		return "Напрягая все силы вы попытались открыть дверь... Не получилось.", false;
	end,
	close = function(s, w)
		return "Нет никакого смысла закрывать эту дверь.", false;
	end,
	used = function(s, w)
		if w == 'stone_key' and not s.Opened then
			s.Opened = true;
			return 'Ключ подошел! Вы открыли дверь!';
		end
	end,
}

halfmoon = sign {
	nam = 'полумесяц',
	desc = 'Сквозь толщу льда на стене вы различаете символ: "{полумесяц}".',
};
halfmoon:disable();

Shrine = iroom {
	nam = 'Усыпальница',
	sw_to = room {
		nam = 'на юго-запад',
		enter = function(s)
			halfmoon:enable();
            		return [[Дальнейший путь в этом направлении пролегает сквозь узкую трещину, 
             пройти которую мешает бесчисленное множество сосулек,
             свисающих с потолка. Сквозь толщу льда на стене с трудом,
             но можно разглядеть символ: "Полумесяц".]], false;
		end,
	},
	way = { vroom('на север', 'Corridor'), 'Shrine.sw_to', vroom('на юго-восток', 'Antechamber') },
	enter = function(s, f)
		if f == 'Corridor' and not StoneDoor.Opened then
			return 'Путь преграждает закрытая дверь.', false
		end
	end,
        desc = [[Величественная гробница, основой для создания которой
             предположительно стала естественная известняковая пещера.
             Это особенно хорошо заметно по двум ее ответвлениям,
             лежащим к юго-западу и юго-востоку от Вас.]],
	obj = { 'paintings', 'stone_table', 'halfmoon' },
	Light = false, 
}
--      se_to Antechamber,

paintings = iobj {
	nam = 'рисунки',
        desc = [[Вы видите очень яркое и живое {изображение}, похожее на настенное граффити --
             могущественный Властитель, попирающий ногами
             поверженного соперника.]],
        exam = function(s)
		m_dlg:pon(1);
		return [[Тела на рисунках кроваво-красные.
             Знаки указывают дату события по календарю майя --
             "10 бактун 4 катун 0 тун 0 уинал 0 кин" -- своеобразная годовщина,
             когда Властитель наконец обезглавливал своего плененного соперника
             после нескольких лет ритуальных пыток,
             как было заведено в городах-государствах майя.]]
     	end
}

stone_table = iobj {
	nam = 'алтарь',
        desc = [[{Алтарь} -- большая каменная плита -- несомненно является
         важнейшей деталью интерьера Усыпальницы.]],
	obj = {'mask' },
}

mask = treasure {
        cultural_value = 10,
	nam = 'маска',
        desc = "На алтаре покоится мозаичная {маска} для лица из нефрита.",
        exam = "За стеклом музейной витрины она будет выглядеть впечатляюще!",
	useit = function(s)
		if not have(s) then
			return 'У меня нет маски...';
		end
		if s.Wear then
			remove('priest', 'Shrine');
			s.Wear = false;
			return 'Вы сняли маску.';
		end
		s.Wear = true;
        	if here() == Shrine then
			move(priest, 'Shrine');
                    return [[Бросив взгляд сквозь затянутые обсидианом глазные прорези,
                     Вы обнаружили, что не одиноки!
                     Рядом с алтарем стоит призрак мумифицированного жреца,
                     безмолвно и безразлично ожидающий Ваших слов.]];
		end
		return 'Вы одели маску.';
	end,
}

m_dlg = dlg {
	Light = true, 
	nam = 'Разговор с мумией',
	dsc = "Жрец закашлялся, отчего едва не распался на части.",
	obj = {
		[1] = _phr('10 бактун, 4 катун -- когда это было?', [[Жрец нахмурился. "10 бактун, 4 катун --
                     иными словами 1 468 800 дней с начала времен.
                     Это 19 января 909 года по вашему календарю,
                     если я не ошибаюсь."]], [[prem(1)]]),
		[2] = phr('Что это за руины? Расскажи мне!',[["Эти руины всегда побеждали грабителей.
                     А в потустороннем мире грабителей и мародеров
                     ожидают вечные мучения."
                     Помолчав, жрец добавил:
                     "Это относится и к тем, которых вы зовете "археологами"."]], [[pon(3)]]),
		[3] = _phr('Это моя работа. И я думаю, что ты служишь бесам.', 'Жрец промолчал.'),
		[4] = phr('Как мне пройти сквозь сеть проходов?', '"Ни один человек не сможет пройти сквозь нее!"'),
		[5] = _phr('Шибальба.',[[Жрец протянул свой костяной палец по направлению к сосулькам,
                     и они мгновенно растаяли, исчезнув без следа!
	     	     "Там лежит Шибальба -- Мир Мертвых."]], [[prem(5); ways(Shrine):add('Junction')]]),
	}
}

Junction = iroom {
	nam = "Шибальба",
	desc = [[
             Вы в пятидесяти метрах под дождевым лесом, и звук капающей воды
             слышится повсюду: эти глубокие, проеденные подземными водами
             известняковые пещеры ветвятся наподобие колоссальных корней.
             Узкая щель ведет назад на северо-восток в Усыпальницу
             мимо широкой рухнувшей колонны из обледеневшего камня.
             Что-то вроде каньона, с белесыми стенами цвета акульих зубов,
             тускло поблескивающими в свете Вашей натриевой лампы,
             проходит рядом вверх на север и вниз на юг.]],
	way = {vroom('на северо-восток', 'Shrine'), vroom('на север', 'Canyon_N'),
			vroom('наверх', 'Canyon_N'),
			vroom('на юг', 'Canyon_S'),
			vroom('вниз', 'Canyon_S'),
		},
	obj = {'stela'},
}

Canyon_N = iroom {
	nam = "Верхний конец каньона",
	desc = [[ Верхний (и более широкий) северный конец каньона
             кончается неровной стеной карстовой пещеры.]],
	way = { vroom('на юг', 'Junction'), vroom('вниз', 'Junction') },
	obj = { 'huge_ball' },
}

Canyon_S = iroom {
	nam = "Нижний конец каньона",
	s_to = room {
		nam = 'на юг',
		enter = function(s)
			if chasm.Ball then
				return goto('On_Ball');
			end
			return 'Прямо в пропасть?', false
		end
	},
	way = { vroom('на север', 'Junction'),
		vroom('наверх', 'Junction'),
		'Canyon_S.s_to',
	},
	obj = { 'chasm' }
}

chasm = iobj {
	nam = "пропасть",
	desc = function(s)
		if s.Ball then
                     return [[Теперь теперь южный конец каньона продолжается
                     большим каменным шаром, намертво застрявшим между
                     стенами {пропасти}.]];
	     	end
		return [[В своем нижнем (и самом узком) южном конце каньон завершается
	             бездонной {пропастью}. Там кромешная, вызывающая головокружение тьма,
        	     из которой не доносится ни единого звука.]];
	end,
        useit = function(s)
                return cat([[Вы не рассуждая бросились в бездонную тьму,
                 раздробив на лету череп об один из каменных уступов.
                 За миг до смерти перед Вами промелькнуло видение --
                 демон с совиной головой...]], goto('gameover'));
	 end,
         exam = "Пропасть глубока и до самых краев заполнена тьмой.",
	 used = function(s, w)
		 inv():del(w);
		 return 'Предмет беззвучо канул в кромешную тьму пропасти.';
	 end,
}

On_Ball = iroom {
	nam = "Каменный мост",
	desc = [[Импровизированный мост, образованный большим шаром из пемзы,
             плотно зажатым между краями пропасти. Так или иначе,
             но путь по каньону здесь завершается.]],
	way = { 'Canyon_S' },
	obj = { 'bone' },
}

bone = treasure {
	nam = 'кость',
        desc = [[От жертвопринощений, брошенных когда-то в эту пропасть,
             чудом уцелело лишь одно: покрытая тонкой резьбой {кость}
             (очень легкая на вид), застрявшая в узкой трещине в стене каньона.]],
        exam = [[ Рука, держащая кисть для рисования, зажата в челюстях Итцамны,
             изобретателя письма (в его змеином обличье).]],
}

huge_ball = iobj {
	nam = "шар",
        desc = "Здесь покоится {шар} из пористого камня восьмифутового диаметра.",
        exam = [[Он диаметром около восьми футов -- но, поскольку камень пористый,
             сравнительно легок.]],
	push = function(s)
		if here() == Canyon_N then
			move(s, 'Canyon_S');
			return 'Напрягая силы, вы столкнули камень...';
		end
		if here() == Canyon_S then
			remove(s);
			chasm.Ball = true;
                	return [[Выскользнув из Ваших рук, огромный каменный шар скатился прямо
                 в раскрытые челюсти пропасти -- и, подскочив назад, нанес Вам
                 скользящий удар по лбу. Обливаясь кровью, Вы упали на него и...^^
                 То ли каменный шар внезапно уменьшился в размерах,
                 то ли Ваша рука резко увеличилась --
                 но теперь шар у Вас в руке, а прямо перед Вами стоит "Аллигатор",
                 "Сын семи ара", на площадке для игры в шары,
                 окруженный насаженными на копья головами своих прежних соперников,
                 и челядью, жадно требующей Вашей крови,
                 и единственное, что Вам остается -- метнуть шар прямо в него...^
                 Но вдруг все это кончилось, и осталась
                 лишь чудовищная головная боль.]];
		end
	end,
	take = function(s)
		return [[Для этого восьмифутовая каменная сфера явно тяжеловата.]], false;
	end,
}

bird = sign {
	nam = 'птица',
--	desc = '{Птица}.',
}

stela_sign = sign {
	nam = 'письмена',
	desc = function(s)
		return 'На стеле вы различаете знак: '..xref('птица.', bird);
	end,
	obj = { 'bird' }
} : disable();

stela = treasure {
	nam = 'стела',
        cultural_value = 5,
        desc = [[Небольшая каменная {стела} возвышается подобно пограничному столбу
             на краю пропасти.]],
        exam = function (s)
		stela_sign:enable();
		return [[Высеченные на стеле знаки, похоже, должны предупреждать,
             что здесь проходит граница Шибальбы -- Мира Смерти.
             Знак "Птица" встречается намного чаще других.]];
	end,
	obj = {'stela_sign'},
}

priest = iobj {
	nam = 'мумия',
        desc = [[За каменным алтарем в безмолвном ожидании стоит {жрец},
             призрачный, но внушающий страх одним своим видом.]],
        exam = [[Частично расчлененный, он держится воедино лишь силой собственной воли.
             И, хотя его родным языком несомненно является местный диалект Майя,
             у Вас откуда-то появилась уверенность, что Вашу речь он также поймет.]],
	talk = function(s)
		return goto('m_dlg');
	end,
	used = function(s, w)
		if w ~= 'dictionary' then
			if w == 'newspaper' then
                    		return [[Жрец бросил взгляд на дату под заголовком.
		                     "12 бактун 16 катун 4 тун 1 уинал 12 кин",
		                     заметил он. "Прогресс, как я посмотрю."]];
			end
			return "Похоже, что его не интересуют вещи материального мира.";
		end
		if dictionary.Correct then
			return '"Словарь? Я вижу."'
		end
		dictionary.Correct = true;
                return [[Жрец просмотрел несколько страниц книги
                     и издал тихий смешок, больше похожий на шепот.
                     Видно не удержавшись, он что-то исправил в словаре,
                     прежде чем вернуть его Вам.]];
	end,
	push = function(s)
		remove(s);
                return [[От легкого прикосновения жрец буквально рассыпался в пыль --
                 от него не осталось и следа.]];
	end,
}

Wormcast = iroom {
	s_to = room {
		nam = 'на юг',
		enter = function(s)
			local ways = { 'Square_Chamber', 'Corridor', 'Forest' };
			local v=[[Узкий проход вокруг Вас стал скользким, 
                   когда тепло Вашего тела растопило лед.
                   Судорожно зажмурившись, Вы заскользили куда-то
                   вниз сквозь темноту.^^]];
			if have('eggsac') then
				return cat(v, goto(Square_Chamber));
			end
			return cat(v, goto(ways[rnd(3)]));
		end,
	},
	d_to = room {
		nam = 'вниз',
		enter = function(s)
		if me() ~= warthog then
               		return [[Хотя интуиция подсказывает Вам, что за сетью проходов может быть
                 	что-то интересное, пролезть сквозь большинство из них
                 	способно лишь животное. Для располневшего от кабинетной работы
                 	археолога эти норы явно слишком узки.]], false;
			end;
		return cat([[Тело вепря быстро растопило лед.-
          	Вы услышали собственный непроизвольный визг, когда,
           	проваливаясь сквозь темноту, свалились прямо в...^^]], goto('Burial_Shaft'));
		end
	},
	nam = 'Сеть "червоточин"',
	desc = [[Здесь каменный пол пещеры изъеден паутиной узких проходов,
             похожих на червоточины. Те из них, сквозь которые можно пролезть,
             ведут на северо-восток, на юг и вверх.]],
	drop = function(s, w)
		drop(w);
		move(w, Square_Chamber);
		return 'О нет!!! Предмет проскользнул в одну из узких нор и исчез из виду.', false;
	end,
	way = { vroom('на запад', 'Square_Chamber'), vroom('на юг', 'Wormcast.s_to'), vroom('вверх', 'Wormcast.s_to'), 
		'Wormcast.d_to'},
	obj = { 'eggsac' },
}

eggsac = iobj {
	nam = 'кокон',
        desc = function(s)
		if s.Trigger then
			return [[Под ногами вы видите {кокон}.]];
		end
		return [[Блестящий склизкий белый {кокон}, похожий на сгусток лягушачей икры,
             полный яиц насекомых, прилепился в узкой расщелине одной из стен.]];
	end,
	take = function(s)
		s.Trigger = true;
		return 'Бррр.';
	end,
	drop = 'Вы бросили кокон на землю.',
	exam = 'Блестящий склизкий белый кокон. В нем яйца насекомых!',
	useit = 'Бррр... Какая гадость...',

}

stone_key = iobj {
	nam = 'ключ',
	exam = "Странной формы ключ из желтого камня.",
	desc = 'Здесь лежит {ключ} из желтого камня.',
	take = 'Вы взяли ключ.',
	drop = 'Вы положили ключ.',
}

gameover = iroom {
	nam = 'Игра окончена',
}

Antechamber = iroom {
	Light = false,
	nam = "Преддверье",
	desc = "Юго-восточная оконечность Гробницы образует довольно интересное место.",
	obj = { 'cage' },
	way = { 'Shrine' },
};

hog = sign {
	nam = 'вепрь',
--	desc = '{Вепрь}.',
};

cage_signs = sign {
	nam = 'письмена',
	desc = function(s)
		return 'На клетке вы различаете символы: '..xref('птица, ', bird)..xref('стрела, ', arrow)..xref('вепрь.', hog);
	end,
	obj = {
		'bird',
		'arrow',
		'hog',
	}
} : disable();

cage = iobj {
	nam = "клетка",
	desc = function(s)
		if s.Opened then
            		return [[Здесь воздвигнута железная {клетка} -- открытая и достаточно большая
		             для того, чтобы Вы могли в нее войти. На ее раме заметны
		             какие-то символы.]];
		end
            	return "Здесь находится закрытая железная {клетка}.";
	end,
        exam = function(s)
		if not s.Opened then
			return 'Клетка закрыта.'
		end
		cage_signs:enable();
		return "Символы на клетке таковы: Птица, Стрела, Вепрь.";
	end,
	open = function(s)
		s.Opened = true -- to not reveal container
		return 'Вы открыли клетку.', false
	end,
	close = 'Вы закрыли клетку.',
	Floor_open = false,
	useit = function(s)
		if s.Opened then
			return cat('Вы вошли в клетку...', goto('incage'));
		end
		return 'Клетка закрыта.';
	end,
	obj = { 'skeletons', 'cage_signs' }
}

noaction = function(s)
	return [[Свиным копытцам такое вряд ли под силу.
                 Помимо ночного зрения и меньшего веса,
                 никаких преимуществ у свиного обличья не заметно --
                 только недостатки.]];
end;

warthog = player {
	nam = "вепрь",
	use = noaction,
	action = noaction,
	Light = true,
	where = 'Antechamber',
}

incage = iroom {
	nam = 'Клетка',
	Light = false,
	life = function(s) -- light ;)
		if Antechamber.Light then
			s.Light = true
		else
			s.Light = false	
		end
	end,
	enter = function(s, f)
		if s.Trigger then
			if not cage.Opened then
				return 'Клетка закрыта.', false
			end
			return
		end
		lifeon('incage');
		ways():add(s);
		cage.Opened = false
		s.Trigger = true;
		objs('cage'):del('skeletons');
                change_pl(warthog);
		goto('Antechamber');
                return [[Обитающие в клетке скелеты внезапно ожили,
                заключив Вас в свои костяные объятия и медленно душа вас!^^
                Вы быстро потеряли сознание -- а когда пришли в себя,
                немедленно пожалели об этом, увидев, что произошло...^^
		Большой вепрь шумно сопит и похрюкивает на грязном полу.
		Здоровенный, грязный, хрюкающий -- и это то, что с вами стало...]], false;
	end,
	desc = function(s)
            if cage.Floor_open then
            	return [[Узкая нора в земляном полу клетки открывает путь вниз,
                 в погребальный колодец.]];
	    end
            return "Толстые прутья железной решетки окружают вас со всех сторон.";
    	end,
	exit = function(s, to)
		if to == 'Antechamber' then
			cage.Opened = true;
		end
	end,
	way = { 'Antechamber' }
};

skeletons = iobj {
	nam = "скелеты",
  	desc =  "Клетка завалена {скелетами}.",
	exam = "Малоприятное зрелище.",
}

low_mist = iobj {
	nam = 'туман',
	desc = "Вы видите густой {туман}, стелящийся по земле.",
        exam = "Туман имеет своеобразный аромат, напоминающий о запахе кукурузных лепешек.",
        take = function(s)
		return "Для этого туман слишком нематериален.", false;
	end,
	push = act.take,
}

Burial_Shaft = iroom {
	up = room {
		nam = 'наверх',
            	enter = function(s)
			if me() == pl then
				return 'Не достать...', false
			end
			pl.where = 'incage';
			change_pl(pl);
			cage.Floor_open = true;
			ways('incage'):add('Burial_Shaft');
			return [[В мощном кабаньем прыжке Вы пробили башкой земляную пробку
             над погребальным колодцем. Что-то безжизненное и очень тяжелое
             обрушилось на Вас сверху вместе с грудами земли -- и, когда Вы
             пришли в себя, Вы поняли, что нечто гротескное и необъяснимое
             произошло вновь...^]], false;
		end,		
	},
	nam = "Погребальный колодец",
	desc = [[Когда-нибудь после, в своих рабочих заметках, Вы напишите следующее:
             "Это была сводчатая колодцеобразная гробница, запечатанная сверху
             осыпавшейся землей. Нарисованные на стенах фигуры, предположительно,
             изображали Девятерых Властителей Ночи. Разбросанные повсюду кости,
             скорее всего, принадлежали принесенным в жертву (одному старику
             и нескольким детям); из других остатков похоронных ритуалов
             можно было видеть лапы ягуара."^^
             (Хорошо, что в дневнике не останется следа того безумного ужаса,
             который Вы сейчас испытываете.) ^^
             Древние архитекторы этого подземелья не предполагали,
             что кому-либо придется выходить отсюда. Хорошо,
             что некий вепрь умудрился прорыться сюда с севера.]],
	way = { vroom('на север', 'Wormcast'), 'Burial_Shaft.up' },
     	obj = { 'honeycomb' },
     }

honeycomb = treasure {
	nam = 'соты',
        desc = "Здесь Вы видите древние, но отлично сохранившиеся {соты} с медом!",
        exam = "Наверное, еще один из приношений усопшему.",
        eat = function(s)
		remove(s);
		return [[Может быть, это был самый дорогостоящий обед в вашей жизни.
                 Конечно, вкус у меда странноватый (возможно потому,
                 что к нему подмешан прах погребенного здесь Владыки) --
                 но все равно, мед остается медом.]];
	end
};

tiny_claws = iobj {
	Turns_active = 0,
	Light = true,
	nam = 'когти',
	desc = [[Тьма бессчетных веков тяжело давит на Вас,
             усиливая чувство клаустрофобии. Где-то в темноте отчетливо слышится
             тихое {поскрипывание крошечных когтей}.]],
        exam = "Для маленьких насекомых звук очень громкий!",
        take = "Как-то не тянет. Честное слово.",
        eat = "Вы явственно ощущаете только один запах -- собственного страха.",
      	useit = "Кто бы они не были, они без труда избегают Ваших неуклюжих рук.",
      	push = [[Крошечные создания без труда уворачиваются от Вас,
                 продолжая шуршать и тихо поскрипывать.]],
	life = function(s)
		if here().Light or me().Light then
			s.Turns_active = 0;
			objs():del(s);
			return
		else
			if not seen(s) then
				objs():add(s);
			end
		end
		s.Turns_active = s.Turns_active + 1
		if s.Turns_active == 2 then
                	return "Шорох и поскрипывание явно приближаются, и Ваше дыхание учащается помимо воли."
		elseif s.Tunrs_active == 3 then
                	return "Вы чувствуете капли холодного пота у себя на лбу. Похоже, что эти твари уже почти здесь!"
		elseif s.Turns_active == 4 then
                	return [[Вы почувствовали, как нечто щекочет Вашу ногу,
                      и судорожным движением стряхнули с нее что-то хитиновое.
                      Вокруг слышится тихий, но угрожающий треск.]];
		elseif s.Turns_active == 5 then
                      return cat([[Внезапно появилась легкая боль -- тонкое, как игла шприца,
                     жало вонзилось Вам в икру. Почти сразу Ваше тело
                     начало содрогаться от спазмов,
                     плечи и колени выгнуло жестокой судорогой,
                     язык начал стремительно раздуваться...]], goto('gameover'));
                end
	end
}
lifeon(sodium_lamp);
lifeon(tiny_claws);

inv():add(sodium_lamp);
inv():add(map);
inv():add(dictionary);

epl = player {
	nam = 'unnamed',
	where = 'main',
};

theend = iroom {
	nam = 'Конец',
	enter = function(s)
		set_music('mus/reinvent.xm');
		inv():zap();
	end,
	desc = [[Вы вернулись в родной Институт с отличными артефактами!^^
	]]..txtc("КОНЕЦ!")..[[^^Да, это неудачная игра. Она перенесена на INSTEAD, чтобы показать его гибкость.
	Если вы читаете этот текст, то, возможно, у вас хватило сил дойти до конца этого кошмара.^^]]..txtc("Поздравляю!")..[[^^
	Но если вы сейчас читаете исходный код игры, то возможно, вы поняли, зачем был написан этот порт.
	Исходный код выглядит не сложнее, чем код игры для Inform.^^
	Если у вас есть желание дописать эту игру, или создать свою историю -- добро пожаловать на наш форум.^^]]..txtc(txtu('http://instead.pinebrush.com'));
};

status = obj {
	nam = function(s)
		local v = 'Очки: '..game.Score..'^';
        	if game.Score >= 30 then
			v = v.."директор Института Карнеги" 
		elseif game.Score >= 20 then
			v = v.."археолог - профессионал"
		elseif game.Score >= 10 then
			v = v.."исследователь"
		elseif game.Score >= 5	then
			v = v.."энтузиаст"
		else
			v = v.. "турист";
		end
		return v..'^';
	end,
};

inv():add('status', 1); -- hack ? Yes!
status.object_type = false

game.pl = 'epl'
pl.where = 'Forest'
